% lab22_ex_ortho.m
clear all; close all;

N  = 20;        % number of orthogonal complex-value carriers, their lengths
fs = 20;        % sampling frequency
k = 5;          % number of the carrier which value is checked
df = fs/1000;   % frequency resolution 

dt = 1/fs; t = 0 : dt : (N-1)*dt;   % sampling period, sampling moments 
f0 = 1/(N*dt); fk = k*f0;           % fundamental and checked carrier frequency
b = exp( -j*2*pi*fk*t );            % reference Fourier harmonic of the carrier
w = boxcar(N)';                     % "no window"
%w = hanning(N)';                   % window used optionally 
f = 0 : df : fs;                    % frequencies of received signal components
for m = 1 : length(f)               % analysis / detection loop
   x = exp( j*2*pi*f(m)*t );        % next component in a received signal 
 % x = cos(   2*pi*f(m)*t );        % next component in a received signal 
   X(m) = sum( b .* (w.* x) )/N;    % its inner product with the reference harmonic
end    
figure; plot( f, abs(X),'b-',f(1:f0/df:end),abs(X(1:f0/df:end)),'ro');
grid; xlabel('f (Hz)'); title('|X_{k}( f(m) )|'); pause
