% lab22_ex_reverb.m
% Generation of reverbation signal used for channel identification
% In Octave: >>pkg load signal[ENTER]
clear all; close all;

N = 512;
b = zeros( N, 1 ); b( 1:9 ) = 1;     % initialization
for i = 10:length(b)
    b(i) = xor( b(i-4), b(i-9) );    % recursive calculations
end
for i = 1:N/2-1
    num(i) = ( 2 * b(2*(i-1)+1) + b(2*(i-1)+2) ) + 1;  % random numbers 1,2,3,4
end
coder = [ -1-j, -1+j, +1-j, +1+j ];      % QPSK=4-QAM constellation points
S0 = coder( num );                       % their random selection
S1  = [ 0 S0 0 conj( S0(end:-1:1) ) ];   % spectrum
x1 = ifft( S1 );                         % real value signal from IFFT

figure; plot( real(S0), imag(S0),'bo'); grid; title('I=f(Q)');
axis( [-1.5, 1.5, -1.5,1.5] ); pause
figure;
subplot(211); plot( real(x1) ); grid; title('Re(x(n))')
subplot(212); plot( imag(x1) ); grid; title('Im(x(n))'); pause
figure; plot( real(xcorr( x1 )) ); grid; title('Auto-correlation of x1(n)'); pause

